<ui:composition xmlns:ui="http://java.sun.com/jsf/facelets" xmlns:h="http://java.sun.com/jsf/html"
                xmlns:gdk="http://www.ihe.net/gazellecdk" xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:f="http://java.sun.com/jsf/core" xmlns:rich="http://richfaces.org/rich"
                xmlns:a4j="http://richfaces.org/a4j" xmlns:g="http://www.ihe.net/gazelle"
                xmlns:gri="http://java.sun.com/jsf/composite/gri"
                xmlns="http://www.w3.org/1999/xhtml" template="//layout/template.xhtml">
    <ui:define name="body">
        <h:form>
            <s:div id="globalDiv">
                <h1>#{messages['gazelle.hl7.validator.DefinitionOfApplicationPreferences']}</h1>
                <ui:decorate template="/layout/panels/_panel_footer.xhtml">
                    <rich:dataTable value="#{applicationManager.getAllPreferences()}" var="pref">
                        <g:column>
                            <ui:define name="header">#{messages['gazelle.hl7.validator.PreferenceName']}</ui:define>
                            <h:outputText value="#{pref.variable}" style="font-weight:bold;"/>
                        </g:column>
                        <g:column>
                            <ui:define name="header">#{messages['gazelle.hl7.validator.PreferenceValue']}</ui:define>
                            <rich:inplaceInput value="#{pref.value}"
                                               defaultLabel="#{messages['gazelle.hl7.validator.PreferenceValue_2']}"
                                               showControls="true" size="16">
                                <a4j:ajax event="change" render="globalDiv"
                                          listener="#{applicationManager.savePreference(pref)}"/>
                            </rich:inplaceInput>
                        </g:column>
                    </rich:dataTable>
                    <ui:define name="panel_footer">
                        <a4j:commandButton value="#{messages['gazelle.hl7.validator.AddAPreference']}"
                                           actionListener="#{applicationManager.createNewPreference()}"
                                           rendered="#{applicationManager.preference == null}" render="globalDiv"
                                           styleClass="gzl-btn-blue"/>
                        <a4j:commandButton value="#{messages['net.ihe.gazelle.hl7.ResetSecurityPreferences']}"
                                           actionListener="#{applicationManager.resetHttpHeaders()}"
                                           rendered="#{applicationManager.preference == null}" render="globalDiv"
                                           styleClass="gzl-btn-orange"/>
                    </ui:define>
                </ui:decorate>
                <h:panelGroup rendered="#{applicationManager.preference != null}">
                    <ui:decorate template="/layout/panels/_panel_title_footer.xhtml">
                        <ui:define name="panel_title">
                            #{messages['gazelle.hl7.validator.NewApplicationPreference']}
                        </ui:define>
                        <div class="form-horizontal">
                            <s:decorate template="/layout/form/_form_field_horizontal_inline.xhtml">
                                <ui:param name="id" value="preferenceName"/>
                                <ui:define name="label">
                                    <h:outputText value="#{messages['gazelle.hl7.validator.PreferenceName']}"/>
                                </ui:define>
                                <h:inputText styleClass="form-control" id="preferenceName"
                                             value="#{applicationManager.preference.variable}"/>
                            </s:decorate>
                            <s:decorate template="/layout/form/_form_field_horizontal_inline.xhtml">
                                <ui:param name="id" value="preferenceValue"/>
                                <ui:define name="label">
                                    <h:outputText value="#{messages['gazelle.hl7.validator.Value']}"/>
                                </ui:define>
                                <h:inputText styleClass="form-control" id="preferenceValue"
                                             value="#{applicationManager.preference.value}"/>
                            </s:decorate>
                        </div>
                        <ui:define name="panel_footer">
                            <a4j:commandButton value="#{messages['gazelle.simulator.Save']}"
                                               actionListener="#{applicationManager.savePreference(applicationManager.preference)}"
                                               render="globalDiv" styleClass="gzl-btn-green"/>
                        </ui:define>
                    </ui:decorate>
                </h:panelGroup>
                <gri:panel pid="updateDiv">
                    <f:facet name="header">
                        #{messages['gazelle.hl7.validator.HL7MessageProfilesAndTablesImport']}
                    </f:facet>
                    <rich:messages globalOnly="true" styleClass="message"/>

                    <div class="form-horizontal">
                        <s:decorate template="/layout/form/_form_checkbox_horizontal_inline.xhtml">
                            <ui:param name="id" value="forceUpdate"/>
                            <ui:define name="label">
                                <h:outputText
                                        value="#{messages['net.ihe.gazelle.hl7.ForceUpdateusedToSyncRevisionNumbers']})"/>
                            </ui:define>
                            <h:selectBooleanCheckbox value="#{applicationManager.forceUpdate}"/>
                        </s:decorate>
                        <s:decorate template="/layout/form/_form_field_horizontal_inline.xhtml">
                            <ui:param name="id" value="directoryPath"/>
                            <ui:define name="label">
                                <h:outputText value="#{messages['gazelle.hl7.validator.PathToHL7MessageProfiles']}"/>
                            </ui:define>
                            <div class="col-sm-6 gzl-no-padding-left">
                                <h:inputText styleClass="form-control gzl-inputFullWidth" id="directoryPath"
                                             value="#{applicationManager.hl7MessageProfileDirectoryPath}"/>
                            </div>
                            <div class="col-sm-6">
                                <a4j:commandButton id="importUpdateProfilesButton"
                                                   value="#{messages['gazelle.hl7.validator.ImportUpdateProfiles']}"
                                                   action="#{applicationManager.importAllProfilesFromDirectory()}"
                                                   render="updateDiv"
                                                   styleClass="gzl-btn-blue"/>
                            </div>
                        </s:decorate>
                        <s:decorate template="/layout/form/_form_field_horizontal_inline.xhtml">
                            <ui:param name="id" value="hl7TablesPath"/>
                            <ui:define name="label">
                                <h:outputText value="#{messages['gazelle.hl7.validator.PathToHL7Tables']}"/>
                            </ui:define>
                            <div class="col-sm-6 gzl-no-padding-left">
                                <h:inputText styleClass="form-control gzl-inputFullWidth" id="hl7TablesPath"
                                             value="#{applicationManager.hl7TablesDirectoryPath}"/>
                            </div>
                            <div class="col-sm-6">
                                <a4j:commandButton id="importUpdateTablesButton"
                                                   value="#{messages['gazelle.hl7.validator.ImportUpdateTables']}"
                                                   action="#{applicationManager.importAllResourcesFromDirectory()}"
                                                   render="updateDiv"
                                                   styleClass="gzl-btn-blue"/>
                            </div>
                        </s:decorate>
                    </div>
                    <s:div rendered="#{applicationManager.validationErrorsMapKeys != null}">
                        <h:outputText
                                value="#{messages['gazelle.hl7.validator.SomeOfTheProcessedFilesContainedErrorsAndHaveNot']}"/>
                        <a4j:repeat value="#{applicationManager.validationErrorsMapKeys}" var="key">
                            <div class="gzl-never-wrap">
                                <h3>#{key}</h3>
                                <a4j:commandButton value="#{messages['gazelle.hl7.validator.ImportWithWarnings']}"
                                                   action="#{applicationManager.importfile(key)}"
                                                   render="updateDiv" styleClass="gzl-btn-orange"/>
                            </div>
                            <rich:list value="#{applicationManager.validationErrorsMap.get(key)}" var="errorMsg"
                                       type="unordered">
                                <h:outputText value="#{errorMsg}"/>
                            </rich:list>
                        </a4j:repeat>
                    </s:div>
                </gri:panel>
            </s:div>
        </h:form>
    </ui:define>
</ui:composition>